{% import 'actions.html' as macros %}

{%- macro workflow_status(jobs) -%}
    {% set statuses = jobs | map(attribute="status") | map('string') | list %}
    {% set invalidated = jobs | map(attribute="workflow_step_invalidated_at") | select("!=", None) | list %}
    {% if 'JobStatus.FAILED' in statuses %}
        <span class="text-ellared-darkest">FAILED</span>
    {% elif 'JobStatus.CANCELLED' in statuses %}
        <span class="text-ellared-darkest">CANCELLED</span>
    {% elif 'JobStatus.HALTED' in statuses %}
        <span class="text-ellared-darkest">HALTED</span>
    {% elif 'JobStatus.RUNNING' in statuses %}
        <span class="text-ellayellow-darkest">RUNNING</span>
    {% elif 'JobStatus.QUEUED' in statuses %}
        <span class="text-ellayellow-darkest">QUEUED</span>
    {% elif 'JobStatus.PENDING' in statuses %}
        <span class="text-ellayellow-darkest">PENDING</span>
    {% elif statuses | select('equalto', 'JobStatus.COMPLETED') | list | length == statuses | length %}
        {% if invalidated %}
            <span
                class="text-ellared-darkest line-through"
                title="One or more steps were invalidated"
                >COMPLETED</span
            >
        {% else %}
            <span class="text-ellagreen-dark">COMPLETED</span>
        {% endif %}
    {% else %}
        <span class="text-ellared-darkest">UNKNOWN</span>
    {% endif %}
{%- endmacro -%}

{%- macro job_status(status, invalidated_at) -%}
    {% set status_str = status | string %}
    {% if status_str == 'JobStatus.FAILED' %}
        <span class="text-ellared-darkest">FAILED</span>
    {% elif status_str == 'JobStatus.CANCELLED' %}
        <span class="text-ellared-darkest">CANCELLED</span>
    {% elif status_str == 'JobStatus.HALTED' %}
        <span class="text-ellared-darkest">HALTED</span>
    {% elif status_str == 'JobStatus.RUNNING' %}
        <span class="text-ellayellow-darkest">RUNNING</span>
    {% elif status_str == 'JobStatus.QUEUED' %}
        <span class="text-ellayellow-darkest">QUEUED</span>
    {% elif status_str == 'JobStatus.PENDING' %}
        <span class="text-ellayellow-darkest">PENDING</span>
    {% elif status_str == 'JobStatus.COMPLETED' %}
        {% if invalidated_at %}
            <span class="text-ellared-darkest line-through" title="Step was invalidated"
                >COMPLETED</span
            >
        {% else %}
            <span class="text-ellagreen-dark">COMPLETED</span>
        {% endif %}
    {% else %}
        <span class="text-ellared-darkest">UNKNOWN</span>
    {% endif %}
{%- endmacro -%}

{%- macro workflow_priority(jobs) -%}
    {% set jobs_priority = jobs | map(attribute="priority") | list %}
    {% if 3 in jobs_priority %}
        <span class="text-ellared-darkest">URGENT</span>
    {% elif 2 in jobs_priority %}
        <span class="text-ellayellow-darkest">HIGH</span>
    {% elif 1 in jobs_priority %}
        <span class="text-ellagreen-dark">NORMAL</span>
    {% else %}
        <span class="text-ellagreen-dark">UNKNOWN</span>
    {% endif %}
{%- endmacro -%}

{%- macro read_priority(priority) -%}
    {% if priority == 3 %}
        <span class="text-ellared-darkest">URGENT</span>
    {% elif priority == 2 %}
        <span class="text-ellayellow-darkest">HIGH</span>
    {% elif priority == 1 %}
        <span class="text-ellagreen-dark">NORMAL</span>
    {% else %}
        <span class="text-ellagreen-dark">UNKNOWN</span>
    {% endif %}
{%- endmacro -%}

<!-- Mouse hover with required inputs for pending -->
{%- macro list_inputs(job) -%}
    {% if job.status | string == 'JobStatus.PENDING' %}
        {% if job.inputs %}
            {%- set inputs_list = [] -%}
            {% for key, value in job.inputs.items() %}
                {%- set details = [] -%}
                {% for k, v in value[1].items() %}
                    {%- set _ = details.append(k ~ ': ' ~ v|e) -%}
                {% endfor %}
                {%- set class_name = value[0].__name__ -%}
                {%- set _ = inputs_list.append(class_name ~ ' | ' ~ details | join(', ') ~ '') -%}
            {% endfor %}
            {%- set required_inputs = 'Required inputs:\n------------------\n' ~ inputs_list | join('\n') -%}
            {{- required_inputs -}}
        {% else %}
            + No required inputs +
        {% endif %}
    {% endif %}
{%- endmacro -%}

<details id="workflow-row-{{ workflow.maestro_id }}" class="workflow-group group">
    <!-- Header-->
    <summary
        class="grid cursor-pointer grid-cols-6 items-start gap-x-5 pb-1.5 pt-2.5 transition-all duration-100 ease-in-out hover:bg-gray-100 group-open:bg-gray-100 group-open:hover:bg-gray-200"
    >
        <div class="col-span-2 flex items-center pl-2">
            <!-- Arrow -->
            <div class="-rotate-90 transition-transform group-open:rotate-0">
                <svg
                    xmlns="http://www.w3.org/2000/svg"
                    viewBox="0 0 20 20"
                    fill="currentColor"
                    class="mr-1 h-4 w-4"
                >
                    <path
                        fill-rule="evenodd"
                        d="M5.23 7.21a.75.75 0 011.06.02L10 11.168l3.71-3.938a.75.75 0 111.08 1.04l-4.25 4.5a.75.75 0 01-1.08 0l-4.25-4.5a.75.75 0 01.02-1.06z"
                        clip-rule="evenodd"
                    />
                </svg>
            </div>
            <div class="truncate" title="{{ workflow.workflow_name }}">
                {{ workflow.workflow_name }}
            </div>
        </div>
        <div class="content-center truncate">{{ workflow_priority(workflow.jobs) }}</div>
        <div
            class="content-center truncate"
            title="{{ workflow.jobs | map(attribute="updated_at") | list | max | dateformat }}"
        >
            {{ workflow.jobs | map(attribute="updated_at") | list | max | dateformat }}
        </div>
        <div class="content-center truncate">{{ workflow_status(workflow.jobs) }}</div>
        <div class="place-self-end pr-3 text-right">
            <!--  Invalidate button with dialogue  -->
            {{ macros.invalidate(workflow.invalidated_at, "None", workflow.maestro_id, "workflow", "nopropagate") }}
        </div>
    </summary>

    <!-- Collapsed section-->
    {% for job in workflow.jobs | sort(attribute='updated_at', reverse=True) %}
        <div
            class="border-ellablue-darker bg-ellablue-superlight grid grid-cols-6 gap-x-5 border-l-4 py-2 transition-all duration-100 ease-in-out hover:bg-gray-200"
        >
            <div class="col-span-2 truncate pl-5" title="{{ job.name }}">{{ job.name }}</div>
            <div class="truncate">{{ read_priority(job.priority) }}</div>
            <div class="truncate" title="{{ job.updated_at | dateformat }}">
                {{ job.updated_at | dateformat }}
            </div>
            <div class="truncate" title="{{ list_inputs(job) }}">
                {{ job_status(job.status, job.workflow_step_invalidated_at) }}
            </div>
            <div
                class="place-self-end whitespace-nowrap pr-3 text-right lg:inline-flex lg:space-x-2"
            >
                {% if job.workflow_step_maestro_id %}
                    <!--
                        Details button for steps with workflow_step_maestro_id
                        This includes completed/running/halted steps, or cancelled/failed from started job
                    -->
                    <button
                        _="on click show #modal-{{ job.workflow_step_maestro_id }} with visibility"
                        hx-get="/content/workflow_step/{{ job.workflow_step_maestro_id }}/artefacts"
                        hx-vals='{ "job_name": "{{ job.name }}", "job_status": "{{ job.status }}", "job_maestro_id": "{{ job.maestro_id }}" }'
                        hx-target="#modal-{{ job.workflow_step_maestro_id }}"
                        hx-trigger="click"
                        hx-swap="innerHTML"
                        type="button"
                        id="details-button_{{ job.workflow_step_maestro_id }}"
                        class="bg-ellablue-darkest hover:bg-ellablue-darker max-h-7 w-24 cursor-pointer select-none rounded-md px-2 py-1 text-sm text-white lg:mr-[6.5rem]"
                        name="details"
                        title="View details and perform actions on step or artefacts"
                    >
                        Details
                    </button>
                {% elif job.status | string in ('JobStatus.PENDING', 'JobStatus.CANCELLED', 'JobStatus.FAILED') %}
                    <!--
                        Details button for pending steps, or cancelled or failed steps that have never started. 
                        These have no workflow_step_maestro_id and use a different endpoint
                    -->
                    <button
                        _="on click show #modal-{{ job.maestro_id }} with visibility"
                        hx-get="/content/job/{{ job.maestro_id }}"
                        hx-params="job_name={{ job.name }}"
                        hx-target="#modal-{{ job.maestro_id }}"
                        hx-trigger="click"
                        hx-swap="innerHTML"
                        type="button"
                        id="details-button_{{ job.maestro_id }}"
                        class="bg-ellablue-darkest hover:bg-ellablue-darker max-h-7 w-24 cursor-pointer select-none rounded-md px-2 py-1 text-sm text-white lg:mr-[6.5rem]"
                        name="details"
                        title="View details about required inputs"
                    >
                        Details
                    </button>
                {% else %}
                    <!-- When noting is available, show disabled button -->
                    <button
                        type="button"
                        id="details-button_{{ job.maestro_id }}"
                        class="max-h-7 w-24 rounded-md bg-gray-200 px-2 py-1 text-sm text-gray-400 lg:mr-[6.5rem]"
                        name="details"
                        title="No details available"
                        disabled
                    >
                        Details
                    </button>
                {% endif %}
            </div>
        </div>
        <!-- Details modal - populated by clicking details-button -->
        {% if job.workflow_step_maestro_id %}
            <div
                id="modal-{{ job.workflow_step_maestro_id }}"
                class="invisible absolute left-0 top-0 z-10 grid h-screen w-screen grid-cols-1 place-items-center bg-gray-400 bg-opacity-70"
            ></div>
        {% elif job.status | string in ('JobStatus.PENDING', 'JobStatus.CANCELLED', 'JobStatus.FAILED') %}
            <!-- Show inputs for pending jobs (no workflow_step_maestro_id). Populated by clicking details-button -->
            <div
                id="modal-{{ job.maestro_id }}"
                class="invisible absolute left-0 top-0 z-10 grid h-screen w-screen grid-cols-1 place-items-center bg-gray-400 bg-opacity-70"
            ></div>
        {% endif %}
    {% endfor %}
</details>
